'use strict'
const exec = require('child_process').exec
const co = require('co')
const prompt = require('co-prompt')
const config = require('../templates')
const chalk = require('chalk')
const util = require('../util')

module.exports = () => {
    co(function*() {
        let templatesKeys = util.getJsonKey2Array(config.tpl)
        console.log(chalk.green('\n √ Please select from the following template!\n'))
        for (let i in config.tpl) {
            console.log(chalk.white(' id:' + util.getArrayIndex(templatesKeys, i) + ' => ' + i))
        }

        let tplId = yield prompt('Template id: ')
        let tplName = templatesKeys[tplId] || ''
        let projectName = yield prompt('Project name: ')
        let gitUrl, branch

        if (!config.tpl[tplName]) {
            console.log(chalk.red('\n × Template does not exit!'))
            process.exit()
        }
        gitUrl = config.tpl[tplName].url
        branch = config.tpl[tplName].branch

        let cmdStr = `git clone -b ${branch} ${gitUrl} ${projectName}`

        console.log(chalk.white('\n Start generating...'))

        exec(cmdStr, (error, stdout, stderr) => {
            if (error) {
                console.log(error)
                process.exit()
            }
            console.log(chalk.green('\n √ Generation completed!'))
            console.log(`\n cd ${projectName} && npm install \n`)
            process.exit()
        })
    })
}
